/*
 * [Twirler.java]
 *
 * Summary: Displays twirling activity indicator on the console.
 *
 * Copyright: (c) 2011 Roedy Green, Canadian Mind Products, http://mindprod.com
 *
 * Licence: This software may be copied and used freely for any purpose but military.
 *          http://mindprod.com/contact/nonmil.html
 *
 * Requires: JDK 1.1+
 *
 * Created with: JetBrains IntelliJ IDEA IDE http://www.jetbrains.com/idea/
 *
 * Version History:
 *  1.0 2011-06-09 initial version.
 */
package com.mindprod.common11;

import java.io.PrintStream;

/**
 * Displays twirling activity indicator on the console.
 *
 * @author Roedy Green, Canadian Mind Products
 * @version 1.0 2011-06-09 initial version.
 * @since 2011-06-09
 */
public final class Twirler
    {
    // ------------------------------ CONSTANTS ------------------------------

    /**
     * chars two create twirling animation.
     */
    private static final String[] TWIRLS = { "/\r", "-\r", "\\\r", "|\r" };

    // ------------------------------ FIELDS ------------------------------

    /**
     * rotation state of the twirling animation
     */
    private int twirlState = 0;

    // -------------------------- PUBLIC INSTANCE  METHODS --------------------------

    /**
     * null constructor
     */
    public Twirler()
        {

        }

    /**
     * make the twirling display kick over 1/8 rev.
     *
     * @param o usually System.out or System.err, where to dispaly twirler.
     */
    public void twirl( PrintStream o )
        {
        o.print( TWIRLS[ twirlState-- ] );
        if ( twirlState < 0 )
            {
            twirlState = 3;
            }
        }
    }
